library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity mpg is
    Port ( btn : in  STD_LOGIC_vector(4 downto 0);
	 clk: in std_logic;
	 en: out std_logic_vector(4 downto 0));
end mpg;


architecture Behavioral of mpg is
signal cnt: std_logic_vector(15 downto 0);
signal endx: std_logic;
signal temp: std_logic_vector(15 downto 0);
signal q1,q2,q3: std_logic_vector(4 downto 0);
begin

	process(clk)
	begin
		if clk='1' and clk'event then
			cnt <= cnt + 1;
		end if;
	end process;

	process(clk)
	begin
		if clk='1' and clk'event then
			if cnt = x"FFFF" then
				q1 <= btn;
			end if;
		end if;
	end process;

	process(clk)
	begin
		if clk='1' and clk'event then
			q2<= q1;
			q3<=q2;
		end if;
	end process;
			
	en <= (not q3) and q2;
end Behavioral;