----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 04/03/2017 08:38:36 PM
-- Design Name: 
-- Module Name: sonar - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL; 

entity sonar is
  Port (
  clk: in STD_LOGIC;
  analog: in STD_LOGIC; -- analog output -- ignored 
  rx: out STD_LOGIC; -- set to 1
  tx: in STD_LOGIC; -- ignored
  pw: inout STD_LOGIC; -- the PWM distance signal
  range_i: out STD_LOGIC_VECTOR(7 downto 0) -- output is the range in inches
   );
end sonar;

architecture Behavioral of sonar is
    signal counter: std_logic_vector(13 downto 0) := (others => '0');  
    signal inches: std_logic_vector(7 downto 0) := (others => '0');
    signal pw_sampled: std_logic;
begin

    process(clk)
    begin
        if rising_edge(clk) then
          if pw_sampled = '1' then
             if counter = 14699 then
                  -- every 147us add an inch to the distance to the target
                  inches <= inches + 1;
                  counter <= (others => '0');
              else
                  counter <= counter + 1;
              end if;
          elsif counter > 0 or inches > 0 then
               -- set the output then reset the counters
                range_i   <= inches;
                counter <= (others => '0');
                inches   <= (others => '0');
           end if;
         -- Sample the PWM signal into a register, to avoid problems with an async signal.
         pw_sampled <= pw;
       end if;
    end process; 
    
    rx <= '1';
    
end Behavioral;
