----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 03/31/2016 03:14:11 PM
-- Design Name: 
-- Module Name: tx_fsm - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity tx_fsm is
    Port ( clk : in STD_LOGIC;
           baud_en : in STD_LOGIC;
           rst : in STD_LOGIC;
           tx_en : in STD_LOGIC;
           tx_data : in STD_LOGIC_VECTOR (7 downto 0);
           tx : out STD_LOGIC;
           tx_rdy : out STD_LOGIC);
end tx_fsm;

architecture Behavioral of tx_fsm is
signal BIT_CNT : std_logic_vector(2 downto 0);
type state_type is (idle, start, bit1, stop);
signal state : state_type;
signal next_state : state_type ;
signal TX_aux : std_logic;
signal TX_RDY_aux : std_logic;
	
    
begin

    FSMU: process (clk, RST, BAUD_EN)
	begin
		if (RST ='1') then
			state <=idle;
		elsif (clk' event and clk = '1' ) then
			if BAUD_EN = '1' then
				case state is
					when idle => 
					   if TX_EN='1' then
					       state <= start;
					   else
							state <= idle;
					   end if;
				    when start => 
						state <= bit1;
						BIT_CNT <= "000";
												
                    when bit1 => 
                        if BIT_CNT = "111" then
                           state <= stop;
                           BIT_CNT <= "000";
                        else
                           state <= bit1;
                           BIT_CNT <= BIT_CNT + 1;
                        end if;
                    when stop =>
                        state <= idle;
                        BIT_CNT <= "000";
                end case;
			end if;
		end if;
    end process;
    
    Process2: process(state, BIT_CNT)
	begin
        case state is	
            when idle =>    TX_RDY <= '1';    TX <= '1'; 
            when start =>   TX_RDY <= '0';    TX <= '0';
            when bit1 =>    TX_RDY <= '0';	  TX <= TX_DATA(conv_integer(BIT_CNT));
            when stop =>    TX_RDY <= '0';	  TX <= '1';
        end case;
    end process process2;
    		
end Behavioral;